//
// NOTE: none of this is really library-worthy in terms of reusable code - each function
//	is only called in one place, but it always seems better to keep the bulky js in an
//	outside script page...
//

/**************************************************************/

/**
 * Sets up the swipe for mobile and keyboard arrow listener for desktop
 */
prepCarouselUsability = function () {

	// swipe for the portfolio for mobile
	$(".block.portfolio").swipe({
		// just let up/down pass on by
		swipeLeft:function(event, direction, distance, duration, fingerCount) {
			carouselOn++;
			moveCarousel(carouselOn);
			return false;			
		},
		swipeRight:function(event, direction, distance, duration, fingerCount) {
			carouselOn--;
			moveCarousel(carouselOn);
			return false;			
		}
	});
	
	// keyboard shortcut for portfolio
	$(document).keydown(function(e){
		if (e.keyCode == 37) { 
			carouselOn--;
			moveCarousel(carouselOn);
			return false;
		} else if (e.keyCode == 39) { 
			carouselOn++;
			moveCarousel(carouselOn);
			return false;
		} 
	});
}

/**
 * Move the carousel (called via swipe event)
 *
 * carouselOn: The current carousel index position
 */
moveCarousel = function (carouselOn) {
	// move it?
	if (carouselOn < 0) {
		carouselOn = 0;
	} else if (carouselOn > carouselSize) {
		carouselOn = carouselSize;			
	} else {
		$("#portfolioSlider").tinycarousel_move(carouselOn);
	}
}

/**
 * Resizes the portfolio areas
 *
 * PENDING: how did this get so convoluted?
 *
 * carouselOn: The current carousel index position
 */
resizePort = function (carouselOn) {
	var winHeight = $(window).height();
	var menuHeight = $("#plWrapper").outerHeight();
	var winHeightMinusFooter = (winHeight - $("#footer").outerHeight());
	var pagerSpace = ($(".pager").outerHeight() * 2);
	var portWidth = Math.floor($("#portfolioSlider").outerWidth() - ($(".buttons.next").outerWidth() * 3));
	
	// the wrapper box
	$("#bwp").css("height", (winHeightMinusFooter + "px"));
	
	// the carousel
	try {
		// height
		$("#portfolioSlider").css("height", ((winHeightMinusFooter - pagerSpace - menuHeight) + "px"));
		$("#portfolioSlider .viewport").css("height", ($("#portfolioSlider").height() - pagerSpace + "px"));
		$("#portfolioSlider .viewport li").css("height", ($("#portfolioSlider .viewport").height() + "px"));
		// image max height (have to do each to isolate box shadow size)
		$(".portImg img").each(function() {
			var bsData = $(this).css("box-shadow").match(/(-?\d+px)|(rgb\(.+\))/g);
			var borders = (parseInt($(this).css("border-top-width")) * 2);
			if (bsData != null) {
				borders += (parseInt(bsData[3]) * 2);
			}
			var mh = ($("#portfolioSlider .viewport").height() - $(".pager").outerHeight() - borders);
			$(this).css("maxHeight", (mh + "px"));
		});
		// iframe height
		$("iframe").css("height", (($("#portfolioSlider .viewport").height()  - 20) + "px"));
		// move buttons to the middle
		$(".buttons").css("marginTop", (((winHeightMinusFooter - ($(".buttons img").height() * 4)) / 2) + "px"));
		// width
		$("#portfolioSlider .viewport").css("width", (portWidth + "px"));
		$("#portfolioSlider .viewport li").css("width", (portWidth + "px"));
		// set the height of the text box to be only as tall as the image
		$(".pText").css("minHeight", ($(".viewport").height() + "px"));
		$(".pText").css("maxHeight", $(".pText").css("minHeight"));
		
		// start the carousel over again
		$("#portfolioSlider").tinycarousel({
			callback: function(element, index){
				carouselOn = (index + 1);
			},
			start: carouselOn,
			pager: true
		});

	} catch (e) { } 
}

/**************************************************************/

/**
 * Adjusts the dimensions of the video based on the size of the window
 *
 * video: The JQuery video tag object
 * w: The original full width of the video
 * h: The original full height of the video
 */
resizeVideo = function (video, w, h) {

	try {

		var ogAspect = (w / h).toFixed(2);
		var borders = 0;

		// figure out borders
		var bsData = video.css("box-shadow").match(/(-?\d+px)|(rgb\(.+\))/g);
		var borders = (parseInt(video.css("border-top-width")) * 2);
		var bordersPlusShadow = borders;
		if (bsData != null) {
			// ie doesn't return the rgb bit
			var pos = (document.all) ? 2 : 3;
			bordersPlusShadow += (parseInt(bsData[pos]) * 2);
		}
		
		// adjust width/height and aspect
		w += bordersPlusShadow;
		h += bordersPlusShadow;

		// figure out the new width/height
		var nw = ($(window).width() <= w) ? $(window).width() : w;
		var nh = (nw / ogAspect);
	
		// ok now is the new height too tall? if so, make the height win
		if (nh > $(window).height()) {
			nh = $(window).height();
			nw = (nh * ogAspect);
		}

		// haaaaaaaaaaaacky
		hackyPadding = (ogAspect == 1.78) ? borders : 0;

		// adjust the video with what we've learned
		video.attr("width", Math.ceil(nw - borders) - hackyPadding);
		video.attr("height", Math.ceil(nh - borders));

		// and adjust the width of the direct link bit
		$("#direct").css("width", ((nw - borders) + "px"));

	} catch (e) { }
}
